#include "../includes/structures.h"
#include "../includes/charge.h"
#include "../includes/main.h"

//Devis

void displayDevis(Devis d)
{
	printf("%s\t%s\t%d\t%d\t%d\n", d.nomE, d.adresse, d.capital, d.duree, d.prix);
}


Devis readDevis(Offre *tabTravaux[]) // A finir
{
	Devis d;
	FILE *devisFile;
	devisFile = fopen("devis.txt", "r");
	char travaux[16];
	int index;
	scanf("%s", travaux);
	index = rechTravaux(travaux, tabTravaux);
	if (index==-1)
	{
		printf("Ces travaux ne sont pas prévus !");
		exit(1);
	}
	fgets(d.nomE, 32, devisFile);
	d.nomE[strlen(d.nomE)-1] = '\0';
	readAdress(devisFile);
	fscanf(devisFile, "%d\n%d\n%d", d.capital, d.duree, d.prix);
	return d;
}

//ListeDevis

ListeDevis newListeDevis(void)
{
	return NULL;
}


ListeDevis delete(ListeDevis l)
{
	MaillonDevis *md;
	if (l==NULL)
	{
		printf("Erreur: suppression dans une liste vide");
		exit(1);
	}
	md=l;
	l=l->suiv;
	free(md);
	return l;
}


ListeDevis insert(ListeDevis l, Devis d)
{
	MaillonDevis *md;
	md = (MaillonDevis *)malloc(sizeof(MaillonDevis));
	if (md == NULL)
	{
		printf("Erreur allocation mémoire");
		exit(1);
	}
	md->dev=d;
	md->suiv=l;
	return md;
}


ListeDevis sortListeDevis(ListeDevis l)
{
	//Tri fusion.
}


Booleen emptyListe(ListeDevis l)
{
	return l==NULL;
}


int lenListeDevis(ListeDevis l)
{
	int len=0;
	while (l)
	{
		len++;
		l=l->suiv;
	}
	return len;
}


void displayListeDevis(ListeDevis l)
{
	while(l)
	{
		displayDevis(l->dev);
		l=l->suiv;
	}
}


//Offre

Offre newOffre(char *travauxName)
{
	Offre o;
	strcpy(o.travaux, travauxName);
	o.ldevis=newListeDevis();
	return o;
}


Booleen emptyOffre(Offre o)
{
	return emptyListe(o.ldevis);
}


void displayOffre(Offre o)
{
	printf("Travaux: %s", o.travaux);
	displayListeDevis(o.ldevis);
}


int rechTravaux(char *travauxName, Offre *tabTravaux[])
{
	int deb=0, end=tmaxTravaux-1, mid; //On utilise la taille max de travaux car travaux est un tableau constant, sa taille max est égale à sa taille logique.
	while(deb<=end)
	{
		mid = deb+end /2;
		if (strcmp(travauxName, tabTravaux[mid]->travaux)==0)
			return mid;
		if (strcmp(travauxName, tabTravaux[mid]->travaux) < 0)
			end=mid-1;
		else
			deb=mid+1;
	}
	return -1;
}